%CompareSpanAndEF.m
%
%Created 9/5/18 by A. Bosen

AnalyzeGroupData;
spanCrossConditionStatistics = crossConditionStatistics;
baseDirectory = pwd();
cd('..\EF Tasks\colorshapetask');

%TODO: Fix this hack
clear percentCorrect;

AnalyzeGroupData;
colorShapeCrossConditionStatistics = crossConditionStatistics;
cd(baseDirectory);

cd('..\EF Tasks\stroopwithvoicerecording');

clear percentCorrect;

AnalyzeGroupData;
stroopCrossConditionStatistics = crossConditionStatistics;
cd(baseDirectory);

%Load TOVA results
TOVAresults = readtable('..\EF Tasks\TOVA Scores.xlsx');

%Build an aggregate table for attention task delta, mean statistics, and CNS values from the TOVA 
attentionTable = table;
attentionTable.Subject = unique(stroopCrossConditionStatistics.subjectID);
attentionTable.PRESTO16Channel = nan(height(attentionTable),1);
attentionTable.PRESTO8Channel = nan(height(attentionTable),1);
attentionTable.PRESTO4Channel = nan(height(attentionTable),1);
attentionTable.PRESTOComposite = nan(height(attentionTable),1);
attentionTable.WASI = nan(height(attentionTable),1);
attentionTable.Span = nan(height(attentionTable),1);
attentionTable.Vocoder = nan(height(attentionTable),1);
attentionTable.ColorShapeDeltaMeanRT = nan(height(attentionTable),1);
attentionTable.StroopDeltaCongruentMeanRT = nan(height(attentionTable),1);
attentionTable.StroopDeltaNeutralMeanRT = nan(height(attentionTable),1);
attentionTable.StroopNeutralCongruentDeltaMeanRT = nan(height(attentionTable),1);
attentionTable.MeanRT = nan(height(attentionTable),1);
attentionTable.MeanMu = nan(height(attentionTable),1);
attentionTable.MeanSigma = nan(height(attentionTable),1);
attentionTable.MeanTau = nan(height(attentionTable),1);
attentionTable.ResponseTimeCNS = nan(height(attentionTable),1);
attentionTable.RTVariabilityCNS = nan(height(attentionTable),1);
attentionTable.ComissionErrorsCNS = nan(height(attentionTable),1);
attentionTable.OmissionErrorsCNS = nan(height(attentionTable),1);

for(subjectIndex = 1:height(attentionTable))
	subjectID = attentionTable.Subject{subjectIndex};

	%Speech recognition score
	if(any(strcmp(spanAndPRESTOTable.Subject,subjectID)))
		attentionTable.PRESTO16Channel(subjectIndex) = spanAndPRESTOTable.PRESTO16Channel(strcmp(spanAndPRESTOTable.Subject,subjectID));
		attentionTable.PRESTO8Channel(subjectIndex) = spanAndPRESTOTable.PRESTO8Channel(strcmp(spanAndPRESTOTable.Subject,subjectID));
		attentionTable.PRESTO4Channel(subjectIndex) = spanAndPRESTOTable.PRESTO4Channel(strcmp(spanAndPRESTOTable.Subject,subjectID));
		attentionTable.PRESTOComposite(subjectIndex) = spanAndPRESTOTable.PRESTOComposite(strcmp(spanAndPRESTOTable.Subject,subjectID));
		attentionTable.Span(subjectIndex) = spanAndPRESTOTable.serialRecallAbility(strcmp(spanAndPRESTOTable.Subject,subjectID));
		attentionTable.Vocoder(subjectIndex) = spanAndPRESTOTable.vocoderSensitivity(strcmp(spanAndPRESTOTable.Subject,subjectID));
	end
	%WASI score
	if(any(strcmp(WASIresults.Subject,subjectID)))
		attentionTable.WASI(subjectIndex) = WASIresults.PRICompositeScore(strcmp(WASIresults.Subject,subjectID));
	end

	%Delta mean RTs
	%We calculate two deltaRTs for stroop, incongruent response RTs relative to the congruent and neutral conditions
	attentionTable.StroopDeltaCongruentMeanRT(subjectIndex) = stroopCrossConditionStatistics.meanRT(strcmp(stroopCrossConditionStatistics.subjectID,subjectID) &...
									strcmp(stroopCrossConditionStatistics.condition,'Incongruent')) - ...
								stroopCrossConditionStatistics.meanRT(strcmp(stroopCrossConditionStatistics.subjectID,subjectID) &...
								 	strcmp(stroopCrossConditionStatistics.condition,'Congruent'));
	attentionTable.StroopDeltaNeutralMeanRT(subjectIndex) = stroopCrossConditionStatistics.meanRT(strcmp(stroopCrossConditionStatistics.subjectID,subjectID) &...
									strcmp(stroopCrossConditionStatistics.condition,'Incongruent')) - ...
								stroopCrossConditionStatistics.meanRT(strcmp(stroopCrossConditionStatistics.subjectID,subjectID) &...
								 	strcmp(stroopCrossConditionStatistics.condition,'Neutral'));
	%For completeness we also calculate the difference between congruent and neutral condition, although that is not considered a variable of interest here.
	attentionTable.StroopNeutralCongruentDeltaMeanRT(subjectIndex) = stroopCrossConditionStatistics.meanRT(strcmp(stroopCrossConditionStatistics.subjectID,subjectID) &...
									strcmp(stroopCrossConditionStatistics.condition,'Neutral')) - ...
								stroopCrossConditionStatistics.meanRT(strcmp(stroopCrossConditionStatistics.subjectID,subjectID) &...
								 	strcmp(stroopCrossConditionStatistics.condition,'Congruent'));
	attentionTable.ColorShapeDeltaMeanRT(subjectIndex) = colorShapeCrossConditionStatistics.meanRT(strcmp(colorShapeCrossConditionStatistics.subjectID,subjectID) &...
									strcmp(colorShapeCrossConditionStatistics.condition,'Shift')) - ...
								colorShapeCrossConditionStatistics.meanRT(strcmp(colorShapeCrossConditionStatistics.subjectID,subjectID) &...
								 	strcmp(colorShapeCrossConditionStatistics.condition,'Repeat'));

	%Average metrics across conditions
	attentionTable.MeanRT(subjectIndex) = mean([stroopCrossConditionStatistics.meanRT(strcmp(stroopCrossConditionStatistics.subjectID,subjectID));...
						colorShapeCrossConditionStatistics.meanRT(strcmp(colorShapeCrossConditionStatistics.subjectID,subjectID))]);
	attentionTable.MeanMu(subjectIndex) = mean([stroopCrossConditionStatistics.mu(strcmp(stroopCrossConditionStatistics.subjectID,subjectID));...
						colorShapeCrossConditionStatistics.mu(strcmp(colorShapeCrossConditionStatistics.subjectID,subjectID))]);
	attentionTable.MeanSigma(subjectIndex) = mean([stroopCrossConditionStatistics.sigma(strcmp(stroopCrossConditionStatistics.subjectID,subjectID));...
						colorShapeCrossConditionStatistics.sigma(strcmp(colorShapeCrossConditionStatistics.subjectID,subjectID))]);
	attentionTable.MeanTau(subjectIndex) = mean([stroopCrossConditionStatistics.tau(strcmp(stroopCrossConditionStatistics.subjectID,subjectID));...
						colorShapeCrossConditionStatistics.tau(strcmp(colorShapeCrossConditionStatistics.subjectID,subjectID))]);
	
	%TOVA metrics
	if(any(strcmp(TOVAresults.Subject,subjectID)))
		attentionTable.ResponseTimeCNS(subjectIndex) = TOVAresults.ResponseTimeCNS(strcmp(TOVAresults.Subject,subjectID));
		attentionTable.RTVariabilityCNS(subjectIndex) = TOVAresults.RTVariabilityCNS(strcmp(TOVAresults.Subject,subjectID));
		attentionTable.ComissionErrorsCNS(subjectIndex) = TOVAresults.ComissionErrorsCNS(strcmp(TOVAresults.Subject,subjectID));
		attentionTable.OmissionErrorsCNS(subjectIndex) = TOVAresults.OmissionErrorsCNS(strcmp(TOVAresults.Subject,subjectID));
	end

end

%Calculate accuracy median and range for each task, show that overall performance was good
disp('********************************************************************************');
disp('Reaction Time Task Accuracy:')
disp(['    Stroop Task Median Accuracy: ' num2str(median(stroopCrossConditionStatistics.percentCorrect))]);
disp(['                          Range: ' num2str(min(stroopCrossConditionStatistics.percentCorrect)) ' - ' num2str(max(stroopCrossConditionStatistics.percentCorrect))]);
disp(['    Color-Shape Task Median Accuracy: ' num2str(median(colorShapeCrossConditionStatistics.percentCorrect))]);
disp(['                               Range: ' num2str(min(colorShapeCrossConditionStatistics.percentCorrect)) ' - ' num2str(max(colorShapeCrossConditionStatistics.percentCorrect))]);

%Verify that we saw a slowing of performance in the incongruent and switch conditions in the attention tasks
disp('********************************************************************************');
disp('Reaction Time Differences in attention tasks (in milliseconds):');
disp('  Stroop Task:');
disp(['    Incongruent-Neutral Median RT Difference: ' num2str(median(attentionTable.StroopDeltaNeutralMeanRT))]);
disp(['                          Sign-Rank p-value : ' num2str(signrank(attentionTable.StroopDeltaNeutralMeanRT))]);
disp(['    Incongruent-Congruent Median RT Difference: ' num2str(median(attentionTable.StroopDeltaCongruentMeanRT))]);
disp(['                            Sign-Rank p-value : ' num2str(signrank(attentionTable.StroopDeltaCongruentMeanRT))]);
disp(['    Neutral-Congruent Median RT Difference: ' num2str(median(attentionTable.StroopNeutralCongruentDeltaMeanRT))]);
disp(['                            Sign-Rank p-value : ' num2str(signrank(attentionTable.StroopNeutralCongruentDeltaMeanRT))]);
disp('  Color-Shape Task:');
disp(['    Median RT Difference: ' num2str(median(attentionTable.ColorShapeDeltaMeanRT))]);
disp(['      Sign-Rank p-value : ' num2str(signrank(attentionTable.ColorShapeDeltaMeanRT))]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Table 3. Correlation of attention metrics with PRESTO accuracy
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('********************************************************************************');
%Remove participants who didn't complete the sentence recognition task
attentionTableWithCompleteData = attentionTable;
attentionTableWithCompleteData(isnan(attentionTableWithCompleteData.PRESTO16Channel),:) = [];
metricIndex = [2:5 9:11];
%This disp is to make column values obvious
disp(attentionTableWithCompleteData.Properties.VariableNames(metricIndex));
corr(attentionTableWithCompleteData{:,metricIndex})

%For just the TOVA we need to omit one additional participant who didn't complete that task
disp('********************************************************************************');
metricIndex = [2:5 17:20];
disp(attentionTableWithCompleteData.Properties.VariableNames(metricIndex));
corr(attentionTableWithCompleteData{~isnan(attentionTableWithCompleteData.ResponseTimeCNS),metricIndex})

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Table 4. Correlation of attention metrics with WASI and serial recall
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('********************************************************************************');
metricIndex = [6 9:11];
%This disp is to make column values obvious
disp(attentionTable.Properties.VariableNames(metricIndex));
corr(attentionTable{~isnan(attentionTable.WASI),metricIndex})

disp('********************************************************************************');
metricIndex = [6 17:20];
disp(attentionTable.Properties.VariableNames(metricIndex));
corr(attentionTable{~isnan(attentionTable.WASI) & ~isnan(attentionTable.ResponseTimeCNS),metricIndex})

disp('********************************************************************************');
metricIndex = [7:8 9:11];
disp(attentionTableWithCompleteData.Properties.VariableNames(metricIndex));
corr(attentionTableWithCompleteData{:,metricIndex})

disp('********************************************************************************');
metricIndex = [7:8 17:20];
disp(attentionTableWithCompleteData.Properties.VariableNames(metricIndex));
corr(attentionTableWithCompleteData{~isnan(attentionTableWithCompleteData.ResponseTimeCNS),metricIndex})

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Table 5. Correlation of attention metrics with WASI and serial recall
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('********************************************************************************');
metricIndex = [6 13:16];
%This disp is to make column values obvious
disp(attentionTable.Properties.VariableNames(metricIndex));
corr(attentionTable{~isnan(attentionTable.WASI),metricIndex})

disp('********************************************************************************');
metricIndex = [2:5 7:8 13:16];
%This disp is to make column values obvious
disp(attentionTableWithCompleteData.Properties.VariableNames(metricIndex));
corr(attentionTableWithCompleteData{:,metricIndex})
