%SplitCVCDataByConfusion.m
%
%Created 11/30/17 by A. Bosen
%
%This function takes CVC data and rounds confusion-based errors to include or exclude these errors
function [dataWithConfusions, dataWithoutConfusions] = SplitCVCDataByConfusion(data)

	%Build two versions of the data, one that includes confusions and one that excludes them
	dataWithConfusions = data;
	dataWithoutConfusions = data;
	for(trialIndex = 1:size(data,1))
		dataWithConfusions.WordsCorrect(trialIndex) = {ceil(dataWithConfusions.WordsCorrect{trialIndex})};
		dataWithConfusions.phonemesCorrect(trialIndex) = {ceil(dataWithConfusions.phonemesCorrect{trialIndex})};
		dataWithConfusions.correctResponse(trialIndex) = ceil(dataWithConfusions.correctResponse(trialIndex));

		dataWithoutConfusions.WordsCorrect(trialIndex) = {floor(dataWithoutConfusions.WordsCorrect{trialIndex})};
		dataWithoutConfusions.phonemesCorrect(trialIndex) = {floor(dataWithoutConfusions.phonemesCorrect{trialIndex})};
		dataWithoutConfusions.correctResponse(trialIndex) = floor(dataWithoutConfusions.correctResponse(trialIndex));
	end

end
